import { OpfsDatabase } from "@sqlite.org/sqlite-wasm";
import { Relation, Config } from "@canvas-js/modeldb";
import { SqlitePrimitiveValue } from "./encoding.js";
export declare class RelationAPI {
    #private;
    readonly db: OpfsDatabase;
    readonly config: Config;
    readonly relation: Relation;
    readonly table: string;
    readonly sourceIndex: string;
    readonly targetIndex: string;
    readonly sourceColumnNames: string[];
    readonly targetColumnNames: string[];
    constructor(db: OpfsDatabase, config: Config, relation: Relation, clear?: boolean);
    drop(): void;
    addTargetIndex(): void;
    removeTargetIndex(): void;
    get(sourceKey: SqlitePrimitiveValue[]): SqlitePrimitiveValue[][];
    add(sourceKey: SqlitePrimitiveValue[], targetKeys: SqlitePrimitiveValue[][]): void;
    delete(sourceKey: SqlitePrimitiveValue[]): void;
    clear(): void;
}
