import { OpfsDatabase } from "@sqlite.org/sqlite-wasm";
import { SqlitePrimitiveValue } from "./encoding.js";
export declare const quote: (name: string) => string;
export declare class Query<P extends SqlitePrimitiveValue[] = SqlitePrimitiveValue[], R extends Record<string, SqlitePrimitiveValue> = Record<string, SqlitePrimitiveValue>> {
    private readonly sql;
    private readonly statement;
    constructor(db: OpfsDatabase, sql: string);
    finalize(): void;
    get(params: P): R | null;
    all(params: P): R[];
    iterate(params: P): IterableIterator<R>;
}
export declare class Method<P extends SqlitePrimitiveValue[] = SqlitePrimitiveValue[]> {
    private readonly sql;
    private readonly statement;
    constructor(db: OpfsDatabase, sql: string);
    finalize(): void;
    run(params: P): void;
}
